import sqlite3
from wsgiref.simple_server import make_server
from urllib.parse import parse_qs


#
# SQL
#
def create_html(dotaz):

    # připojení k SQLite-databázi
    connection = sqlite3.connect('../monitory.sqlite')
    cursor = connection.cursor()

    # zpracování dat
    cursor.execute(f'''
        SELECT * FROM monitory
            WHERE brand LIKE "%{dotaz}%";
    ''')

    # HTML-data odpovědi
    body = ''

    # styly
    body += '''
    <style>
        tr:nth-child(2n) {}
        tr:nth-child(2n+1) { background-color: lightblue; }
    </style>
    '''
    # tabulka
    body += '<table border>\n'
    # hlavičkový řádek
    body += '<tr style="background-color: yellow;">\n'
    body += f'''
        <th>
            brand
            <form method="POST">
                <input type="text" name="brand" value="{dotaz}">
            </form>
        </th>
        <th>model</th>
        <th>size</th>
        <th>hres</th>
        <th>vres</th>
        <th>aspect</th>
        <th>inputs</th>
        <th>support</th>
        <th>year</th>
        <th>comments</th>
    '''
    body += '</tr>\n'
    # data
    for řádka in cursor:
        _, brand, model, size, hres, vres, aspect, inputs, support, year, comments = řádka
        body += f'''
            <tr>
                <td>{brand}</td>
                <td>{model}</td>
                <td>{size}</td>
                <td>{hres}</td>
                <td>{vres}</td>
                <td>{aspect}</td>
                <td>{inputs}</td>
                <td>{support}</td>
                <td>{year}</td>
                <td>{comments}</td>
            </tr>
        '''
    # konec
    body += '</table>\n'

    # uzavření spojení
    cursor.close()
    connection.close()
    
    # vrácení vyrobené HTML-stránky
    return body



#
# WSGI-klient
#
def application(environ, start_response):
    # A) zpracování HTTP-request
    # ~ Při prvním dotazu na web je environ['CONTENT_LENGTH'] prázdný řetězec.
    # ~ Po vyplnění formuláře obsahuje v binární podobě dotaz.
    cl_as_string = environ['CONTENT_LENGTH']
    print('CONTENT_LENGTH:', cl_as_string)
    if cl_as_string == '':
        cl = 0
    else:
        cl = int(cl_as_string)
    data = environ['wsgi.input'].read(cl)
    print('data binary:', data)
    # nenahráváme žádný soubor => budeme předstírat, že to je QS
    dotaz = data.decode('UTF-8')
    print('data string:', dotaz)
    # zpracujeme QS na dotaz pro databázi
    if dotaz in ('', 'brand='):
        parametr = ''
    else:
        form = parse_qs(dotaz)
        print('wsgi.input parsed:', form)
        parametr = form['brand'][0]
    # B) dotaz do databáze a vytvoření výstupní HTML-stránky
    html = create_html(parametr)
    # C) výroba HTTP-response
    if html is None:
        html = ''
    data = bytes(html, encoding='utf-8')
    response_headers = [
        ("Content-type", "text/html; charset=UTF-8"),
        ("Content-length", str(len(data)) ),
    ]
    start_response("200 OK", response_headers)
    return (data,)
 
# WSGI-server (spuštěn pro jednu odpověď)
server = make_server('localhost', 8080, application)
server.serve_forever()
